function encode_param(p) {
    var encoded = p; // catch curly quotes and replace with straight quotes
    encoded = encoded.replace(/”|“/, '"');
    encoded = encoded.replace(/‘|’/, "'");
    encoded = encoded.replace(/'/g, "PB2apos;");
    return encoded;
}

function tellSU(element) {
    id = element.id;
    value = element.value;
    sketchup.ValueChanged(id, value);
}

function tellSU2(element, valueElementId) {
    id = element.id;
    value = document.getElementById(valueElementId).value;
    sketchup.ValueChanged(id, value);
}

function tellSU3(element, value) {
    id = element.id;
    sketchup.ValueChanged(id, value);
}

function tellSUcb(element) {
    id = element.id;
    value = element.checked;
    sketchup.ValueChanged(id, value);
}

function set_checkbox_by_value(id) {
    var checkbox = document.getElementById(id);
    checkbox.checked = (checkbox.value == 'true');
}

function set_checkbox_value(id) {
    var checkbox = document.getElementById(id);
    checkbox.value = checkbox.checked;
}

function setMultiSelect(id, values) {
    var id_selector = '#'+id;
    $(id_selector+' option').prop('selected',false);

    var valuesLength=values.length;
    for (var i=0;i < valuesLength;i++) {
    	option = values[i];
    	$(id_selector+' option[value='+option+']').prop('selected',true);
    }
    $(id_selector).multiselect('refresh');
}

function buttonClicked(element) {
    // Ensure that any active input fields will fire their onchange event prior to
    // the dialog firing the event for this button click
    unfocusActiveElement();
    tellSU(element);
}
 
function createOption(id,option_name)
{
    var op=document.createElement('option');
    op.text=option_name
    op.value=option_name
    document.getElementById(id).add(op);
}

function createOptionAndValue(id,option_name,value_name)
{
    var op=document.createElement('option');
    op.text=option_name
    op.value=value_name
    document.getElementById(id).add(op);
}

function clearList(id)
{
    list=document.getElementById(id)
    list_length=list.length
    for (i=0;i<list_length;i++){
    list.remove(0)
    }
}

function unfocusActiveElement() {
    if (document.activeElement != document.body) {
        document.activeElement.blur();
    }
}

function ensure_tool_settings_are_updated(){
    if (document.activeElement != document.body) {
        window.location = 'skp:triggerOnChangeEvent';
    }
}
 
function detectIE() {
    var ua = window.navigator.userAgent;
 
    var msie = ua.indexOf('MSIE ');
    if (msie > 0) {
        // IE 10 or older => return version number
        return true;
    }
 
    var trident = ua.indexOf('Trident/');
    if (trident > 0) {
        // IE 11 => return version number
       return true;
    }
 
    var edge = ua.indexOf('Edge/');
    if (edge > 0) {
      return true;
    }
 
    // other browser
    return false;
}

 
//Credit to Julia Eneroth for this code
function port_key(){
  //Sends the keycode from the event to a Ruby callback.
  //This can be used for web dialogs inside a custom tools to send key events to the tool to change its behavior even when the web dialog is focused.
  //Run "document.onkeyup=port_key;" to initialize. onkeyup is used to avoid overriding calls to onkeydown already in use in the dialog. onkeypress doesn't fire for modifier keys.
  e = window.event || e;
  keycode = e.keyCode || e.which
   
  //It might be wise to only proceed for certain keys here, e.g. modifier keys or whatever keys are used in the tool.
   
  window.location='skp:port_key@' + keycode;
}

// https://www.w3schools.com/howto/howto_js_image_magnifier_glass.asp
function magnify(imgID, zoom) {
    var img, glass, w, h, bw;
    var padding = 16;
    img = document.getElementById(imgID);
    /*create magnifier glass:*/
    glass = document.createElement("DIV");
    glass.setAttribute("class", "img-magnifier-glass");
    /*insert magnifier glass:*/
    img.parentElement.insertBefore(glass, img);
    /*set background properties for the magnifier glass:*/
    glass.style.backgroundImage = "url('" + img.src + "')";
    glass.style.backgroundRepeat = "no-repeat";
    glass.style.backgroundSize = ((img.width + padding) * zoom) + "px " + ((img.height + padding) * zoom) + "px";
    bw = 1;
    w = glass.offsetWidth / 2;
    h = glass.offsetHeight / 2;
    /*execute a function when someone moves the magnifier glass over the image:*/
    glass.addEventListener("mousemove", moveMagnifier);
    glass.addEventListener("mouseover", showMagnifier);
    glass.addEventListener("mouseleave", hideMagnifier);
    img.addEventListener("mousemove", moveMagnifier);
    img.addEventListener("mouseover", showMagnifier);
    /*and also for touch screens:*/
    glass.addEventListener("touchmove", moveMagnifier);
    img.addEventListener("touchmove", moveMagnifier);
    function moveMagnifier(e) {
        var pos, x, y;
        /*prevent any other actions that may occur when moving over the image*/
        e.preventDefault();
        /*get the cursor's x and y positions:*/
        pos = getCursorPos(e);
        x = pos.x;
        y = pos.y;
        /*prevent the magnifier glass from being positioned outside the image:*/
        padding = 16; // Needs to match the total padding applied to the image
        if (x > (img.width + padding) - (w / zoom)) {x = (img.width + padding) - (w / zoom);}
        if (x < w / zoom) {x = w / zoom;}
        if (y > (img.height + padding) - (h / zoom)) {y = (img.height + padding) - (h / zoom);}
        if (y < h / zoom) {y = h / zoom;}
        /*set the position of the magnifier glass:*/
        glass.style.left = (x - w) + "px";
        glass.style.top = (y - h) + "px";
        /*display what the magnifier glass "sees":*/
        glass.style.backgroundPosition = "-" + ((x * zoom) - w + bw) + "px -" + ((y * zoom) - h + bw) + "px";
    }
    function getCursorPos(e) {
        var a, x = 0, y = 0;
        e = e || window.event;
        /*get the x and y positions of the image:*/
        a = img.getBoundingClientRect();
        /*calculate the cursor's x and y coordinates, relative to the image:*/
        x = e.pageX - a.left;
        y = e.pageY - a.top;
        /*consider any page scrolling:*/
        x = x - window.pageXOffset;
        y = y - window.pageYOffset;
        return {x : x, y : y};
    }
}

function showMagnifier() {
    $(".img-magnifier-glass").show();
}

function hideMagnifier() {
    $(".img-magnifier-glass").hide();
}

function setButtonActive(id) {
    $("#" + id).addClass("active");
}

function setButtonInactive(id) {
    $("#" + id).removeClass("active");
}

// Localization
var l10n_strings = {};

function l10n(string) {
    var result = l10n_strings[string];
    if (result === undefined) {
        return string;
    } else {
        return result;
    }
}

// Call this method from WebDialog.
function localize(strings) {
    l10n_strings = strings;
    $(".localize").each(function() {
        var $this = $(this);
        var type = $this.prop('tagName').toLowerCase();
        var input, output = '';

        switch(type) {
            case "input":
                // Translate input placeholders
                input = $this.attr("placeholder");
                output = l10n(input);
                $this.attr("placeholder", output);
                // Translate button values
                input = $this.attr("value");
                output = l10n(input);
                $this.attr("value", output);
                break;

            default:
                input = $this.text();
                output = l10n(input);
                $this.text(output);
        }

    });
    $('[title]').each(function() {
        var $this = $(this);
        var input = $this.prop('title');
        var output = l10n(input);
        $this.prop('title', output);
    });
}

function disableContextMenu() {
    $(document).on('contextmenu', function(e) {
        return $(e.target).is('input[type=text]');
    });
}

function disableSelect() {
    $(document).on('mousedown selectstart', function(e) {
        return $(e.target).is('input, textarea, select, option');
    });
}

function activateButton(id) {
    $("#" + id).addClass("active");
}

function deactivateButton(id) {
    $("#" + id).removeClass("active");
}

function applyEventsToTextbox() {
    var onFocus = function() { $(this).select(); };

    $('input:text').each(function() {
        $(this).off('focus');
        $(this).on('focus', onFocus);

        var onKeyDownExists = $(this).attr('onKeyDown');
        // Don't overwrite an existing onKeyDown event if it exist
        if (onKeyDownExists === undefined) {
            var element = $(this)[0];
            var onKeydown = function(evt) {
                if (evt.keyCode == 13) {
                    // onBlur will trigger onChange and also internally update the html's "Was OnChange applied" logic.
                    // So avoids triggering onChange again when losing focus to that inputbox.
                    $(this).blur();
                    // Note: Doesn't work if the input box value is changed via ruby (IE: When updating a Length).
                    //       selectAllWhenFocused must be called from ruby
                    $(this).select();
                }
            }

            $(this).off('keydown');
            $(this).on('keydown', onKeydown);
        }
    });
}

function selectAllWhenFocused(){
    var activeElement = document.activeElement;
    if (activeElement != null) {
        var jElement = $(activeElement);
        if (jElement.is("input") && jElement.attr('type') == 'text' && jElement.attr('data-no-focus') == undefined) {
            jElement.select();
        }
    }
}

function ready() {
    applyEventsToTextbox();
    disableContextMenu();
    disableSelect();
    window.location = 'skp:ready';
}